<template>
    <div>

        <Userform v-bind:user="user" v-on:submit="register()" v-on:back="back()" pwd=false>

        </Userform>

        <button class="btn btn-danger" type="button" v-on:click="remove()"> supprimer </button>
    </div>
</template>

<script>

import Userform from './UserForm.vue'
import router from '@/router/Admin/users.js';
import {
    editUser, deleteUser
} from '@/api/users.service.js'
import { getInfo } from '@/api/auth.service.js';
export default {
    created: function() {
        this.$store.dispatch("getAllUsers").then((users) => {
            this.users = users;
            this.user = this.getuser(this.$route.params.id)
        });

    }, computed: {
        users() {
            return this.$store.getters.AllUsers
        }
    },

    data() {
        return {
            user: {

            },
            confirm: "",
            interact: true,
            color: "black",
            msg: "Veuillez remplir le formulaire"
        }
    },
    methods: {
        register: function() {
            editUser(this.user._id, this.user).then((response) => {
                getInfo(localStorage.getItem('token')).then((response) => {
                    let user = response.body.data;
                    this.$store.dispatch('setCurrentUser', user);
                });
                this.$router.go(-1);
            }).catch((error) => {
                if (error.status === 400) {
                    this.msg = "Cette adresse est déjà utilisée ou invalide";
                    this.color = "red";
                } else {
                    this.msg = "une erreur s'est produite, Veuillez réssayez";
                    this.color = "red";

                }
            })

        },

        remove: function() {
            deleteUser(this.user._id).then(() => {
                this.$router.go(-1);
            }).catch((err) => {
                console.log(err)
            })
        },

        back: function() {
            console.log('hello');
            this.$router.go(-1);
        },


        getuser: function(id) {
            for (var i = 0; i < this.users.length; i++) {
                if (id === this.users[i]._id) {
                    return this.users[i];
                }
            }
            return {

            }
        }

    }, components: {
        Userform
    }

}
</script>

<style scoped>
.black {
    color: black;
}

.red {
    color: red;
}
</style>
